function g = gf (x, m, p)  
  if (nargin < 1 || nargin > 3)
    print_usage ();
  endif
  if (isa (x, "gf"))
    g = x;
  else
    if (nargin < 2)
      m = 1;
    endif
    if (m < 1 || m > 16 || fix(m) != m)
      error ("gf: m must be an integer between 1 and 16");
    endif

    if (nargin < 3)
      p = primpoly (m, "nodisplay");
    else
      if (! isprimitive (p, m))
	error ("gf: polynomial is not primitive");
      endif
    endif

    if (any (x(:)) >= 2.^m || any (x(:)) < 0 || any (x(:) != fix(x(:))))
      error ("gf: x must be an array of integers between 0 and 2.^m - 1");
    endif

    g.x = x;
    g.prim_poly = p;
    g.m = m;
    g.n = 2.^m - 1;
    [g.alpha_to, g.index_of] = cachefield (m, p);
    g = class (g, "gf");
  endif
endfunction
