function p = primpoly (m, opt, nodisp)
  p = [];

  if (nargin < 1 || nargin > 3)
    print_usage ();
  elseif (nargin > 1)
    if (strcmp (opt, "nodisplay"))
      if (nargin == 2)
	nodisp = opt;
	opt = "min";
      else
	tmp = nodisp
	nodisp = opt;
	opt = tmp;
      endif
    else
      nodisp = "display";
    endif
  else
    opt = "min";
    nodisp = "display";
  endif

  if (strcmp (opt, "min"))
    for i = 2.^m + 1: 2 :  2.^ (m + 1)
      if (isprimitive(i, m))
        p = i;
        break;
      endif
    endfor
  elseif (strcmp (opt, "max"))
    for i = 2.^(m + 1) -1 : -2 :  2.^ m
      if (isprimitive(i, m))
        p = i;
        break;
      endif
    endfor
  elseif (strcmp (opt, "all"))
    for i = 2.^m + 1: 2 :  2.^ (m + 1)
      if (isprimitive(i, m))
        p = [p, i];
      endif
    endfor
  elseif (isscalar (opt))
    for i = 2.^m + 1: 2 :  2.^ (m + 1)
      ki = 0;
      for j = 1 : m + 1
	if (bitget (i, j) != 0)
	  ki++;
	endif
      endfor
      if (ki == opt && isprimitive(i, m))
        p = [p, i];
      endif
    endfor
  else
    error ("primpoly: unrecognized optional argument");
  endif

  if (! strcmp (nodisp, "nodisplay"))
    fprintf("\nPrimitive polynomial(s) =\n\n");
    for j = 1 : length (p)
      first = true;
      for i = m + 1 : -1 : 1
	if (bitget (p(j), i) != 0)
	  if (i > 1)
	    if (first)
	      first = false;
	      fprintf("D")
	    else
	      fprintf("+D")
	    endif
	    if (i != 2)
	      fprintf("^%d", i - 1);
	    endif
	  else
	    if (first)
	      first = false;
	      fprintf("1");
	    else
	      fprintf("+1");
	    endif
	  endif
	endif
      endfor
      fprintf("\n");
    endfor
    fprintf("\n");
  endif

endfunction
